###############################################################
# Tracking Demo, Group1 XY set to track Analog input from PSD #
###############################################################

set TimeOut		10
set Group		"XY"
set Positioner1		"XY.X"
set Positioner2		"XY.Y"
set AnalogInput1 "GPIO2.ADC1"
set AnalogInput2 "GPIO2.ADC2"
set Offset 0
set Scale "-10"
set DeadBandThreshold 0.02
set Order 1
set Velocity 125
set Acceleration 400
set TrackingType "Velocity"


# Open a socket and enable use of XPS APIs from TCL
set code [catch "OpenConnection $TimeOut socketID"]
if {$code == 0} {
# Kill the group to restart from a known state
#	set code [catch "GroupKill $socketID $Group"]
#	if {$code == 0} {
# Initialize the group
#		set code [catch "GroupInitialize $socketID $Group"]
#		if {$code == 0} {
# Home the group
#			set code [catch "GroupHomeSearch $socketID $Group"]
#			if {$code == 0} {
# Set Tracking parameters
set code [catch "PositionerAnalogTrackingVelocityParametersSet $socketID $Positioner1 $AnalogInput1 $Offset $Scale $DeadBandThreshold $Order $Velocity $Acceleration"]
set code [catch "PositionerAnalogTrackingVelocityParametersSet $socketID $Positioner2 $AnalogInput2 $Offset $Scale $DeadBandThreshold $Order $Velocity $Acceleration"]
				if {$code == 0} {
# Enable Tracking mode (group must be Ready)
set code [catch "GroupAnalogTrackingModeEnable $socketID $Group $TrackingType"]
#set code [catch "GroupAnalogTrackingModeEnable $socketID $Group $TrackingType"]
					if {$code != 0} {
                  					puts stdout "Enable Tracking mode failed => error = $code"
							}
				} else {
				puts stdout "Set Tracking parameters failed => error = $code"
					}
#			} else {
#				puts stdout "Group Home search failed => error = $code"
#				}
#		} else {
#			puts stdout "Group initialize failed => error = $code"
#		       }
#	} else {
#		puts stdout "Group kill failed => error = $code"
#	       }

# close socket
	set code [catch "TCP_CloseSocket $socketID"]
	if {$code != 0} {
			puts stdout "TCP_CloseSocket => $code  ID = $socketID"
			}
} else {
        puts stdout "OpenConnection failed => error = $code"
       }

