############################################ 
# 
# TCL generation of history
# 
############################################ 

# Display error and close procedure
proc DisplayErrorAndClose {socketID code APIName} {
	global tcl_argv
	if {$code != -2 && $code != -108} {
		set code2 [catch "ErrorStringGet $socketID $code strError"]
		if {$code2 != 0} {
			puts stdout "$APIName ERROR => $code - ErrorStringGet ERROR => $code2"
			set tcl_argv(0) "$APIName ERROR => $code"
		} else {
			puts stdout "$APIName $strError"
			set tcl_argv(0) "$APIName $strError"
		}
	} else {
		if {$code == -2} {
			puts stdout "$APIName ERROR => $code : TCP timeout"
			set tcl_argv(0) "$APIName ERROR => $code : TCP timeout"
		} 
		if {$code == -108} {
			puts stdout "$APIName ERROR => $code : The TCP/IP connection was closed by an administrator"
			set tcl_argv(0) "$APIName ERROR => $code :  The TCP/IP connection was closed by an administrator"
		} 
	}
	set code2 [catch "TCP_CloseSocket $socketID"] 
	return
}

# Main process 
set TimeOut 20 
set code 0 

# Open TCP socket 
OpenConnection $TimeOut socketID 
if {$socketID == -1} { 
	puts stdout "OpenConnection failed => $socketID" 
	return 
} 

set code [catch "GroupInitialize $socketID GROUP4"] 
if {$code != 0} { 
	DisplayErrorAndClose $socketID $code "GroupInitialize" 
	return 
} 

set code [catch "GatheringConfigurationSet $socketID GROUP4.POSITIONER.CurrentPosition"] 
if {$code != 0} { 
	DisplayErrorAndClose $socketID $code "GatheringConfigurationSet" 
	return 
} 

set code [catch "EventExtendedConfigurationTriggerSet $socketID Immediate 0 0 0 0"] 
if {$code != 0} { 
	DisplayErrorAndClose $socketID $code "EventExtendedConfigurationTriggerSet" 
	return 
} 

set code [catch "EventExtendedConfigurationActionSet $socketID GROUP4.POSITIONER.GatheringRun 10000 100 0 0"] 
if {$code != 0} { 
	DisplayErrorAndClose $socketID $code "EventExtendedConfigurationActionSet" 
	return 
} 

set code [catch "EventExtendedStart $socketID arg1"] 
if {$code != 0} { 
	DisplayErrorAndClose $socketID $code "EventExtendedStart" 
	return 
} 

set code [catch "GroupHomeSearch $socketID GROUP4"] 
if {$code != 0} { 
	DisplayErrorAndClose $socketID $code "GroupHomeSearch" 
	return 
} 

set code [catch "GatheringStopAndSave $socketID "] 
if {$code != 0} { 
	DisplayErrorAndClose $socketID $code "GatheringStopAndSave" 
	return 
} 


# Close TCP socket 
TCP_CloseSocket $socketID 
