VERSION 5.00
Begin VB.Form XPS 
   Caption         =   "MainFrame"
   ClientHeight    =   6300
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5085
   LinkTopic       =   "Form1"
   ScaleHeight     =   6300
   ScaleWidth      =   5085
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton GroupKillButton 
      Caption         =   "Group kill"
      Height          =   375
      Left            =   2760
      TabIndex        =   13
      Top             =   3960
      Width           =   1935
   End
   Begin VB.CommandButton GroupAbsoluteMoveButton 
      Caption         =   "Group absolute move "
      Height          =   375
      Left            =   2760
      TabIndex        =   12
      Top             =   3360
      Width           =   1935
   End
   Begin VB.CommandButton PositionerAbsoluteMoveButton 
      Caption         =   "Positioner absolute move"
      Height          =   375
      Left            =   2760
      TabIndex        =   11
      Top             =   2760
      Width           =   1935
   End
   Begin VB.CommandButton HomeSearchButton 
      Caption         =   "Home search"
      Height          =   375
      Left            =   2760
      TabIndex        =   10
      Top             =   2160
      Width           =   1935
   End
   Begin VB.CommandButton InitializeGroupButton 
      Caption         =   "Initialize group"
      Height          =   375
      Left            =   2760
      TabIndex        =   9
      Top             =   1560
      Width           =   1935
   End
   Begin VB.CommandButton GatheringGetButton 
      Caption         =   "Get Gathering"
      Height          =   375
      Left            =   360
      TabIndex        =   8
      Top             =   3960
      Width           =   1935
   End
   Begin VB.CommandButton GatheringSetButton 
      Caption         =   "Set Gathering"
      Height          =   375
      Left            =   360
      TabIndex        =   7
      Top             =   3360
      Width           =   1935
   End
   Begin VB.CommandButton ErrorButton 
      Caption         =   "Error"
      Height          =   375
      Left            =   360
      TabIndex        =   5
      Top             =   2160
      Width           =   1935
   End
   Begin VB.CommandButton AnalogGPIOButton 
      Caption         =   "Analog GPIO"
      Height          =   375
      Left            =   360
      TabIndex        =   4
      Top             =   2760
      Width           =   1935
   End
   Begin VB.TextBox Message 
      Height          =   1575
      Left            =   360
      MultiLine       =   -1  'True
      TabIndex        =   3
      Top             =   4560
      Width           =   4335
   End
   Begin VB.CommandButton CloseButton 
      Caption         =   "Close"
      Height          =   375
      Left            =   2760
      TabIndex        =   2
      Top             =   600
      Width           =   1935
   End
   Begin VB.CommandButton VersionButton 
      Caption         =   "Version"
      Height          =   375
      Left            =   360
      TabIndex        =   1
      Top             =   1560
      Width           =   1935
   End
   Begin VB.CommandButton OpenButton 
      Caption         =   "Open connection"
      Height          =   375
      Left            =   360
      TabIndex        =   0
      Top             =   600
      Width           =   1935
   End
   Begin VB.Frame Frame1 
      Caption         =   "Communication TCP / IP"
      Height          =   1095
      Left            =   120
      TabIndex        =   6
      Top             =   120
      Width           =   4815
   End
End
Attribute VB_Name = "XPS"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Public Buffer As String
Public CommOpened As Boolean
Public IPAddress As String
Public IPPort As Integer
Public SocketID As Integer

Public GroupName As String
Public PositionerName1 As String
Public PositionerName2 As String
Public PositionerName3 As String

'/////////////////////////////////////
' Initialization
'/////////////////////////////////////
Private Sub Form_Load()
    SocketID = -1
    CommOpened = False
    IPAddress = "192.168.33.234"
    IPPort = 5001
    Buffer = String(512 + 1, 0)
    
    GroupName = "MyGroup"
    PositionerName1 = "MyGroup.Positioner1"
    PositionerName2 = "MyGroup.Positioner2"
    PositionerName3 = "MyGroup.Positioner3"
    
End Sub

'/////////////////////////////////////
' Close TCP IP connection
'/////////////////////////////////////
Private Sub CloseButton_Click()
    TCP_CloseSocket (SocketID)
    SocketID = -1
    CommOpened = False
End Sub



'/////////////////////////////////////
' Open TCP IP connection
'/////////////////////////////////////
Private Sub OpenButton_Click()
    Dim error As Long
    If CommOpened = False Then
        SocketID = TCP_ConnectToServer(IPAddress, IPPort, 10)
        If SocketID <> -1 Then
            error = FirmwareVersionGet(SocketID, ByVal Buffer)
            Message.Text = Buffer
            CommOpened = True
        Else
            Message.Text = "Communication failed"
        End If
    End If
End Sub

'/////////////////////////////////////
' Get firmware version
'/////////////////////////////////////
Private Sub VersionButton_Click()
    Dim error As Long
    If CommOpened = True Then
        error = FirmwareVersionGet(SocketID, ByVal Buffer)
        Message.Text = Buffer
    End If
End Sub

'/////////////////////////////////////
' Get error message
'/////////////////////////////////////
Private Sub ErrorButton_Click()
    Dim error As Long
    If CommOpened = True Then
        error = ErrorStringGet(SocketID, 0, Buffer)
        Message.Text = Buffer
    End If
End Sub

'/////////////////////////////////////
' Set and Get analog GPIO
'/////////////////////////////////////
Private Sub AnalogGPIOButton_Click()
    Dim error As Long
    Dim AnalogValue() As Double
    Dim AnalogNameList As String
    
    ReDim AnalogValue(4)
        
    If CommOpened = True Then
    
        AnalogNameList = "GPIO2.DAC1;GPIO2.DAC2;GPIO2.DAC3;GPIO2.DAC4"
        AnalogValue(0) = 1
        AnalogValue(1) = 2
        AnalogValue(2) = 3
        AnalogValue(3) = 4
        
        error = GPIOAnalogSet(SocketID, 4, AnalogNameList, AnalogValue(0))
        If (error = 0) Then
            error = GPIOAnalogGet(SocketID, 4, AnalogNameList, AnalogValue(0))
            If (error = 0) Then
                Message.Text = "GPIO2.DAC1 = " & AnalogValue(0) & "  GPIO2.DAC2 = " & AnalogValue(1) & "GPIO2.DAC3 = " & AnalogValue(2) & "  GPIO2.DAC4 = " & AnalogValue(3)
            Else
                err = ErrorStringGet(SocketID, error, Buffer)
                Message.Text = Buffer
            End If
        Else
            err = ErrorStringGet(SocketID, error, Buffer)
            Message.Text = Buffer
        End If
    End If
End Sub

'/////////////////////////////////////
' Set gathering configuration
'/////////////////////////////////////
Private Sub GatheringSetButton_Click()
    Dim error As Long
    Dim GatheringTypeListSet As String
       
    If CommOpened = True Then
    
        GatheringTypeListSet = "GPIO2.DAC1;GPIO2.DAC2;GPIO2.DAC3;GPIO2.DAC4"
        
        error = GatheringConfigurationSet(SocketID, 4, GatheringTypeListSet)
        If (error <> 0) Then
            err = ErrorStringGet(SocketID, error, Buffer)
            Message.Text = Buffer
        End If
    End If
End Sub

'/////////////////////////////////////
' Get gathering configuration
'/////////////////////////////////////
Private Sub GatheringGetButton_Click()
    Dim error As Long
       
    If CommOpened = True Then
       
        error = GatheringConfigurationGet(SocketID, Buffer)
        If (error = 0) Then
            Message.Text = Buffer
        Else
            err = ErrorStringGet(SocketID, error, Buffer)
            Message.Text = Buffer
        End If
    End If

End Sub

'/////////////////////////////////////
' Initialize group
'/////////////////////////////////////
Private Sub InitializeGroupButton_Click()
    Dim error As Long
    If CommOpened = True Then
        error = GroupInitialize(SocketID, GroupName)
        Message.Text = error
        
        Dim ret As Integer
        ret = ErrorStringGet(SocketID, error, Buffer)
        Message.Text = "GroupInitialize => " + Buffer
    End If
End Sub

'/////////////////////////////////////
' Home search
'/////////////////////////////////////
Private Sub HomeSearchButton_Click()
    Dim error As Long
    If CommOpened = True Then
        error = GroupHomeSearch(SocketID, GroupName)
        
        Dim ret As Integer
        ret = ErrorStringGet(SocketID, error, Buffer)
        Message.Text = "GroupHomeSearch => " + Buffer
    End If
End Sub

'/////////////////////////////////////
' Positioner absolute move
'/////////////////////////////////////
Private Sub PositionerAbsoluteMoveButton_Click()
    Dim error As Long
    If CommOpened = True Then
        error = GroupMoveAbsolute(SocketID, PositionerName1, 1, 0)
        
        Dim ret As Integer
        ret = ErrorStringGet(SocketID, error, Buffer)
        Message.Text = "GroupAbsoluteMove(" + PositionerName1 + ",0) => " + Buffer
    End If
End Sub

'/////////////////////////////////////
' Group absolute move
'/////////////////////////////////////
Private Sub GroupAbsoluteMoveButton_Click()
    Dim error As Long
    Dim AbsoluteMoveArray() As Double
    
    ReDim AbsoluteMoveArray(3)
    AbsoluteMoveArray(0) = 5
    AbsoluteMoveArray(1) = 5
    AbsoluteMoveArray(2) = 5
    
    If CommOpened = True Then
        error = GroupMoveAbsolute(SocketID, GroupName, 3, AbsoluteMoveArray(0))
    
        Dim ret As Integer
        ret = ErrorStringGet(SocketID, error, Buffer)
        Message.Text = "GroupAbsoluteMove(" + GroupName + ",5,5,5) => " + Buffer
    End If
End Sub

'/////////////////////////////////////
' Group kill
'/////////////////////////////////////
Private Sub GroupKillButton_Click()
    Dim error As Long
    If CommOpened = True Then
        error = GroupKill(SocketID, GroupName)
    
        Dim ret As Integer
        ret = ErrorStringGet(SocketID, error, Buffer)
        Message.Text = "GroupKill => " + Buffer
    End If
End Sub
