# Process to set up an analog tracking.

# Initialization
set TimeOut 60

set Group "XY"
set Positioner "XY.X"

set AnalogInput "GPIO2.ADC1"
set Offset 0
set Scale 1
set Velocity 18
set Acceleration 70

set TrackingType "Position"

set ErrCode    0

# Open TCP socket
set ErrCode [catch "OpenConnection $TimeOut socketID"]

# Initialize Group
#set ErrCode [catch "GroupInitialize $socketID $Group"]

# Search home Group
#set ErrCode [catch "GroupHomeSearch $socketID $Group"]

# Set Tracking parameters
set ErrCode [catch "PositionerAnalogTrackingPositionParametersSet $socketID $Positioner $AnalogInput $Offset $Scale $Velocity $Acceleration"]

# Enable Tracking mode (group must be Ready)
#set ErrCode [catch "GroupAnalogTrackingModeEnable $socketID $Group $TrackingType"]
set ErrCode [catch "GroupAnalogTrackingModeEnable $socketID $Positioner $TrackingType"]

# Disable Tracking mode
#set ErrCode [catch "GroupAnalogTrackingModeDisable $socketID $Group"]
#set ErrCode [catch "GroupAnalogTrackingModeDisable $socketID $Positioner"]

# Close TCP socket 
#set ErrCode [catch "TCP_CloseSocket $socketID"]
