############################################ 
# 
# TCL generation of history
# 
############################################ 

# Display error and close procedure
proc DisplayErrorAndClose {socketID code APIName} {
	global tcl_argv
	if {$code != -2 && $code != -108} {
		set code2 [catch "ErrorStringGet $socketID $code strError"]
		if {$code2 != 0} {
			puts stdout "$APIName ERROR => $code - ErrorStringGet ERROR => $code2"
			set tcl_argv(0) "$APIName ERROR => $code"
		} else {
			puts stdout "$APIName $strError"
			set tcl_argv(0) "$APIName $strError"
		}
	} else {
		if {$code == -2} {
			puts stdout "$APIName ERROR => $code : TCP timeout"
			set tcl_argv(0) "$APIName ERROR => $code : TCP timeout"
		} 
		if {$code == -108} {
			puts stdout "$APIName ERROR => $code : The TCP/IP connection was closed by an administrator"
			set tcl_argv(0) "$APIName ERROR => $code :  The TCP/IP connection was closed by an administrator"
		} 
	}
	set code2 [catch "TCP_CloseSocket $socketID"] 
	return
}

# Main process 
set TimeOut 20 
set code 0 

# Open TCP socket 
OpenConnection $TimeOut socketID 
if {$socketID == -1} { 
	puts stdout "OpenConnection failed => $socketID" 
	return 
} 

set code [catch "KillAll $socketID "] 
if {$code != 0} { 
	DisplayErrorAndClose $socketID $code "KillAll" 
	return 
} 

set code [catch "GroupInitialize $socketID S"] 
if {$code != 0} { 
	DisplayErrorAndClose $socketID $code "GroupInitialize" 
	return 
} 

set code [catch "GroupInitialize $socketID XY"] 
if {$code != 0} { 
	DisplayErrorAndClose $socketID $code "GroupInitialize" 
	return 
} 

set code [catch "GroupHomeSearch $socketID S"] 
if {$code != 0} { 
	DisplayErrorAndClose $socketID $code "GroupHomeSearch" 
	return 
} 

set code [catch "GroupHomeSearch $socketID XY"] 
if {$code != 0} { 
	DisplayErrorAndClose $socketID $code "GroupHomeSearch" 
	return 
} 

set code [catch "GroupMoveRelative $socketID S.Rotation 12"] 
if {$code != 0} { 
	DisplayErrorAndClose $socketID $code "GroupMoveRelative" 
	return 
} 

set code [catch "GroupMoveRelative $socketID XY.X-Axis 25"] 
if {$code != 0} { 
	DisplayErrorAndClose $socketID $code "GroupMoveRelative" 
	return 
} 

set code [catch "GroupMoveRelative $socketID XY.Y-Axis 15"] 
if {$code != 0} { 
	DisplayErrorAndClose $socketID $code "GroupMoveRelative" 
	return 
} 


# Close TCP socket 
TCP_CloseSocket $socketID 
